Subject: RE: draft-yoon-pkix-wireless-internet-00.txt

From: "Hallam-Baker, Phillip" <[email-masked]>
Date: Mon, 26 Nov 2001 11:44:04 -0800

Just to throw in my ECU 0.03...

I don't see much value in introducing new protocols that are simply syntax
conversions of existing ones. That is why XKMS does not simply convert X.509
cert formats into XML. The problem is that however bad you think a syntax is
the problem of getting to critical mass is a bigger one.

		Phill

Phillip Hallam-Baker FBCS C.Eng.
Principal Scientist
VeriSign Inc.
[email-masked]
781 245 6996 x227

> -----Original Message-----
> From: Eric Rescorla [mailto:[email-masked]]
> Sent: Monday, November 26, 2001 1:39 PM
> To: Housley, Russ
> Cc: Jaeho Yoon; [email-masked]
> Subject: Re: draft-yoon-pkix-wireless-internet-00.txt
> 
> 
> 
> "Housley, Russ" <[email-masked]> writes:
> > You said:
> > >We had to consider the size of ASN.1 run-time library and 
> its actual code 
> > >size and processing time including key generation in 
> mobile devices. We 
> > >just have maximum 150Kbyte in a brand-new mobile phone. 
> And it was nearly 
> > >impossible to make a partial revision of commercial ASN.1 
> product without 
> > >manufacturerâEUR(tm)s (OSS etc.) assistance. So we tested not 
> an ASN.1 but 
> > >different methods again and again. Fortunately, we ported the PKI 
> > >application at mobile devices and have finished testing 
> it. Now, We are 
> > >ready to launch the service.
> > 
> > I have experience with ASN.1 data structures limited processing 
> > environments, specifically smart cards.  In this 
> environment, we did could 
> > not use a general purpose toolkit for the reasons that you discuss 
> > above.  However, we found that there were very few ASN.1 
> data structures 
> > that actually needed to be processed in the limited processing 
> > environment.  In some cases, only decoders were needed.  In 
> other case, 
> > only encoders were needed.  In very few cases, both 
> encoders and decoders 
> > were needed.  Therefore, we simply wrote code for the 
> structures that we 
> > cared about.  The resulting structure-specific code was 
> very small, and it 
> > had no burdensome run-time requirements (like large 
> tables).  It appears to 
> > me that similar code could be used to implement the ASN.1 
> structures that 
> > your draft proposes to eliminate.
> I've got to agree with Russ here. Writing a generalized ASN.1 parser
> is quite a bit of work. Writing a primitive decoder for a few specific
> data structures is straightforward (though tedious) and can be 
> executed within quite a small footprint.
> 
> -Ekr
> 
> 
> -- 
> [Eric Rescorla                                   [email-masked]]
>                 http://www.rtfm.com/
>